----------------------------------------------------
----------------------------------------------------
-- THIS FILE WAS GENERATED BY VISUAL ELITE
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
----------------------------------------------------
----------------------------------------------------
-- GNU LESSER GENERAL PUBLIC LICENSE
----------------------------------------------------
-- This source file is free software; you can redistribute it and/or modify it
-- under the terms of the GNU Lesser General Public License as published by the
-- Free Software Foundation; either version 2.1 of the License, or (at your
-- option) any later version. This source is distributed in the hope that it
-- will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- See the GNU Lesser General Public License for more details. You should have
-- received a copy of the GNU Lesser General Public License along with this
-- source; if not, download it from http://www.gnu.org/licenses/lgpl-2.1.html
----------------------------------------------------
----------------------------------------------------
--
--  Library Name :  CommonVisual
--  Unit    Name :  BusRotate
--  Unit    Type :  Text Unit
--
------------------------------------------------------
------------------------------------------
------------------------------------------
-- Date        : Wed Jul 1 11:33:54 2015
--
-- Author      : J.C.Molendijk
--
-- Company     :
--
-- Description : A generic bus signal rotator
--
------------------------------------------
------------------------------------------
library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.numeric_std.all;

library work;
use work.Util.all;

entity  BusRotate  is

port (Din   : in  std_logic_vector ;
      DinRot: out std_logic_vector
     );
end;

------------------------------------------
------------------------------------------
-- Date        : Wed Jul 1 11:33:54 2015
--
-- Author      : J.C.Molendijk
--
-- Company     : CERN dept. BE/RF
--
-- Description : A generic bus signal rotator
--
------------------------------------------
------------------------------------------
architecture  V1 of BusRotate  is

begin

  process(Din)
    begin
      for i in Din'high - Din'low downto 0
        loop
          DinRot(i + Din'low) <= Din(to_integer(not(to_unsigned(i,log2(Din'length)-1))) + Din'low);
        end loop;
    end process;

end;


