----------------------------------------------------
----------------------------------------------------
-- THIS FILE WAS GENERATED BY VISUAL ELITE
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
----------------------------------------------------
----------------------------------------------------
-- GNU LESSER GENERAL PUBLIC LICENSE
----------------------------------------------------
-- This source file is free software; you can redistribute it and/or modify it
-- under the terms of the GNU Lesser General Public License as published by the
-- Free Software Foundation; either version 2.1 of the License, or (at your
-- option) any later version. This source is distributed in the hope that it
-- will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- See the GNU Lesser General Public License for more details. You should have
-- received a copy of the GNU Lesser General Public License along with this
-- source; if not, download it from http://www.gnu.org/licenses/lgpl-2.1.html
----------------------------------------------------
----------------------------------------------------
--
--  Library Name :  CommonVisual
--  Unit    Name :  CRC32_D16
--  Unit    Type :  Text Unit
--
------------------------------------------------------
------------------------------------------
------------------------------------------
-- Date        : Mon september 15 15:06:54 2014
--
-- Author      : J. Molendijk
--
-- Company     : CERN BE-RF-CS
--
-- Description : A 32 bit CRC IEEE 802.3 table driven encoder circuit
--               with Parallel 16 bit interface
--
------------------------------------------
------------------------------------------
library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.numeric_std.all;
library work;
use work.PCK_CRC32_D16.all;

entity CRC32_D16 is

generic (InitVal : std_logic_vector(31 downto 0):= (others => '0'));

port (Clk,Rst : in std_logic ;
      Din     : in std_logic_vector(15 downto 0);
      DinEna  : in std_logic;
      CRC     : out std_logic_vector(31 downto 0);
      NxtCRC  : out std_logic_vector(31 downto 0);
      Clear   : in std_logic);
end entity CRC32_D16;

------------------------------------------
------------------------------------------
-- Date        : Mon september 15 15:06:54 2014
--
-- Author      : J. Molendijk
--
-- Company     : CERN BE-RF-CS
--
-- Description : A 32 bit CRC IEEE 802.3 table driven encoder circuit
--               with Parallel 16 bit interface
--
------------------------------------------
------------------------------------------
architecture  V1  of  CRC32_D16  is

--constant Zero   : Std_logic_vector(31 downto 0):= (others => '0');

signal CRC_loc  : Std_logic_vector(31 downto 0);

begin

CRC_Enc: process(Clk, Rst)
  begin
    if rising_edge(Clk) then
      if Rst = '1' then
          CRC_loc <= InitVal;
      elsif Clear = '1' then
          CRC_loc <= InitVal;
      elsif DinEna = '1' then
          --CRC encoder function
          CRC_loc<=nextCRC32_D16(Din, CRC_loc);
      end if;
    end if;
  end process CRC_Enc;

CRC <= CRC_loc;
NxtCRC <= nextCRC32_D16(Din, CRC_loc);

end V1;


