----------------------------------------------------
----------------------------------------------------
-- THIS FILE WAS GENERATED BY VISUAL ELITE
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
----------------------------------------------------
----------------------------------------------------
-- GNU LESSER GENERAL PUBLIC LICENSE
----------------------------------------------------
-- This source file is free software; you can redistribute it and/or modify it
-- under the terms of the GNU Lesser General Public License as published by the
-- Free Software Foundation; either version 2.1 of the License, or (at your
-- option) any later version. This source is distributed in the hope that it
-- will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
-- of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- See the GNU Lesser General Public License for more details. You should have
-- received a copy of the GNU Lesser General Public License along with this
-- source; if not, download it from http://www.gnu.org/licenses/lgpl-2.1.html
----------------------------------------------------
----------------------------------------------------
--
--  Library Name :  GTP
--  Unit    Name :  GTP_CommaTable
--  Unit    Type :  Truth Table
--
------------------------------------------------------

library ieee;
use ieee.STD_LOGIC_1164.all;
use ieee.NUMERIC_STD.all;
entity GTP_CommaTable is
  port (
        Mode : in std_logic_vector(1 downto 0 );
        Disp : in std_logic;
        Comma : out std_logic_vector(19 downto 0 );
        DispInv : out std_logic
        );

end GTP_CommaTable;


architecture GTP_CommaTable of GTP_CommaTable is


begin
  GTP_CommaTable:
  process (Mode, Disp)
  begin

    if (Mode = "01") AND
       (Disp = '0') then
      Comma <= "0011111001" & "1001000101";
      DispInv <= '0';
    --  Ch Bond (K28.1, D16.2)
    elsif
          (Mode = "01") AND
          (Disp = '1') then
      Comma <= "1100000110" & "0110110101";
      DispInv <= '0';
    --  Ch Bond (K28.1, D16.2)
    elsif
          (Mode = "10") AND
          (Disp = '0') then
      Comma <= "1110101000" & "1110101000";
      DispInv <= '0';
    --  Car Ext (K23.7, K23.7)
    elsif
          (Mode = "10") AND
          (Disp = '1') then
      Comma <= "0001010111" & "0001010111";
      DispInv <= '0';
    --  Car Ext (K23.7, K23.7)
    elsif
          (Disp = '0') then
      Comma <= "0011111010" & "1001000101";
      DispInv <= '0';
    else
      --  Comma (K28.5, D16.2)

      --  Comma (K28.5, D05.6)
      Comma <= "1100000101" & "1010010110";
      DispInv <= '1';
    end if ;
  end process GTP_CommaTable;

end GTP_CommaTable;

